# Prueba de un árbol de búsqueda binario
# y algunas operacione en él
#
# Fraga 05.11.2021
# Fraga 05.11.2021

import arbol

#
#                    6
#            5                7
#        2       5                   8

# Construyo explícitamente este árbol:

raiz = arbol.Nodo( 6 )

raiz.izq = arbol.Nodo( 5 )
raiz.izq.p = raiz
raiz.der = arbol.Nodo( 7 )
raiz.der.p = raiz

raiz.izq.izq = arbol.Nodo(2)
raiz.izq.izq.p = raiz.izq
raiz.izq.der = arbol.Nodo(5)
raiz.izq.der.p = raiz.izq

raiz.der.der = arbol.Nodo(8)
raiz.der.der.p = raiz.der

# Algunas operaciones en el árbol

arbol.camina_en_orden( raiz )
print( )

p = arbol.busca_minimo( raiz )
print( p.llave )

p = arbol.busca_maximo( raiz )
print( p.llave )

p = arbol.busca_minimo( raiz.der )
print( p.llave )


p = arbol.sucesor( raiz )
print( "Sucesor raíz", p.llave )
